{% extends 'accueil-prof.html' %}

{% block title %}
  <title>Modifier le scénario</title>
{% endblock %}

{% block head_suplementaire %}
  <link rel="stylesheet" href="{{ url_for('static', filename='css/modifier-scenario.css') }}">
  <link rel="stylesheet" href="{{ url_for('static', filename='css/modal.css') }}">
{% endblock %}

{% block header_titre %}
  <h3 id="header-titre">Modifier le scénario de "{{ escape.nom }}"</h3>
{% endblock %}

{% block contenu_onglet %}
  <section>
    <section id="boxCanvas">
      <ion-icon name="arrow-back-circle-outline" size="large" onClick="let ul = document.getElementById('main').children[2].children[0].children[1].children[1]; ul.scrollLeft -= ul.children[0].offsetWidth+20;"></ion-icon>
      <ul>
        {% for salle in listeSalles %}
          <button {% if salle.id == salleCourante.id %}selected{% endif %} onClick="location.href='/scenario/modifier/{{ escape.id }}/salle/{{ salle.id }}';"> Salle {{ loop.index }} </button>
        {% endfor %}
        <button title="Ajouter une salle" onClick="location.href='/scenario/modifier/{{ escape.id }}/salle/ajouter/{{ listeSalles|length +1 }}';"> <ion-icon name="add-circle-outline" size="small"></ion-icon> </button>
      </ul>
      <ion-icon name="arrow-forward-circle-outline" size="large" onClick="let ul = document.getElementById('main').children[2].children[0].children[1].children[1]; ul.scrollLeft += ul.children[0].offsetWidth+20;"></ion-icon>
    </section>
  </section>

  <aside>
    <form id="form_datas" action="/scenario/modifier/{{ escape.id }}/salle/modifier/{{ salleCourante.id }}" method="POST">
      <input name="hiddenImageFond" id="hiddenImageFond" type="hidden" />
      <input name="listeZones" id="inputListeZones" type="hidden" />
      <section>
        <h2>zones</h2>
        <ul id="outils">
          <ion-icon title="Mode navigation" value="nav" onClick="changerOutil(this);" name="information-circle-outline" size="small"></ion-icon>
          <ion-icon title="Mode dessin" value="des" onClick="changerOutil(this);" name="square-outline" size="small"></ion-icon>
          <ion-icon title="Mode déplacement" value="dep" onClick="changerOutil(this);" name="move" size="small"></ion-icon>
          <ion-icon title="Mode suppression" value="sup" onClick="changerOutil(this);" name="trash" size="small"></ion-icon>
        </ul>
      </section>
      <ul>
        <li>
          <h2>Salle</h2>
          <ul>
            <ion-icon title="Supprimer la salle" onClick="if(confirm('Êtes-vous certain de vouloir supprimer cette salle ? \nCette opération est irréversible !')){location.href='/scenario/modifier/{{ escape.id }}/salle/supprimer/{{ salleCourante.id }}'};" name="trash" size="small"></ion-icon>
            <ion-icon title="Choisir une image de fond" onclick="document.getElementById('inputImageFond').click();" name="image" size="small"></ion-icon>
          </ul>
          <input onchange="changerFond();" type="file" id="inputImageFond" accept="image/*">
          <p title="Choisisez si les étudiants peuvent passer dans cette salle librement ou non. La première salle est libre par defaut pour que les étudiants puissent commencer quelque part."><ion-icon name="information-circle-outline"></ion-icon>Liberté de la salle</p>
          {% if salleCourante.ordre_salle == 1 %}
            <input type="text" value="Pas de blocage (defaut)" readonly/>
            <input type="hidden" value="1" name="estLibre"/>
          {% else %}
            <select form="form_datas" name="estLibre">
              <option value="0" {% if salleCourante.est_libre == 0 %} selected {% endif %}>Résoudre une énigme avant</option>
              <option value="1" {% if salleCourante.est_libre == 1 %} selected {% endif %}>Pas de blocage</option>
            </select>
          {% endif %}
          <p>Description</p>
          <textarea name="descriptionSalle" placeholder="Ma merveilleuse salle">{{ salleCourante.desc }}</textarea>
        </li>

        <li id="affichage_zone_enigmes">
          <h2>Enigmes - Indices</h2>
          <p title="Le mode Aléatoire ira chercher dans la liste des énigmes globales de la plateforme pour en choisir une en fonction de la difficulté et du thème chosi. Le mode Manuel vous permet de créer directement votre énigme et vos indices ou de choisir une énigme pré-enregistrée en particulier pouer cette salle."><ion-icon name="information-circle-outline"></ion-icon>Mode de choix de l'énigme</p>
          <select form="form_datas" name="estPersonalisee" onchange="enregistrerDonnees();">
            <option value="0" {% if salleCourante.est_personnalisee == 0 %} selected {% endif %}>Choix aléatoire</option>
            <option value="1" {% if salleCourante.est_personnalisee == 1 %} selected {% endif %}>Choix manuel</option>
          </select>
          <div couleur="button" onclick="afficherModal('modal2');"><ion-icon name="settings" size="small"></ion-icon>Parametres</div>
        </li>
      </ul>
    </form>

    {% if salleCourante.est_personnalisee == 1 %}
      <div id="modal1" class="modal">
        <section>
          <section>
            <button onclick="closeModal();afficherModal('modal2');"><ion-icon name="arrow-back-outline" size="small"></ion-icon>Retour</button>
            <h2>Gestion des indices</h2>
            <button couleur='validation' onclick="sauvegarderIndices();"><ion-icon name="save" size="small"></ion-icon>Valider</button>
          </section>
          <div>
            <ion-icon name="information-circle-outline" size="large"></ion-icon>
            <p>Chaque indice seras placé aléatoirement dans les zones : il est important de fournir plus d'indices qu'il n'y a de zones.
              Sans zone, certains indices pourraient ne pas apparaitre.</p>
          </div>
          <section>
            <h3>Liste des indices</h3>
            <div couleur="validation" onclick="nouveauIndice(this.parentNode.parentNode.children[3]);"><ion-icon name="add-circle-outline" size="small"></ion-icon>Nouveau</div>
          </section>
          <ul>
            {% if listeIndices != [] %}
              {% for indice in listeIndices %}
                <li>
                  <input onchange="actualiserIndice(this);" placeholder="Écrivez ici !" ref="{{ indice.id }}" type="text" value="{{ indice.contenu }}" />
                  <ion-icon onClick="supprimerIndice(this);" name="trash" size="large"></ion-icon>
                  <div>
                      <div>
                        <div couleur="button" title="Changer l'image associée à l'indice" onclick="document.getElementById('inputImageIndice-{{ indice.id }}').click();">
                          <ion-icon name="image" size="small"></ion-icon>
                        </div>
                        <input onchange="changerImageIndice(this);" type="file" id="inputImageIndice-{{ indice.id }}" accept="image/*" />
                        <img value="{{ indice.id }}" {% if indice.image %} src="{{ indice.image.image }}" {% else %} style="display:none" {% endif %} alt="Image de l'indice" title="Agrandir l'image" onClick="window.open(this.src, '_blank');"/>
                      </div>
                    {% if listeModeleEnigmes %}
                      <div>Relié à l'énigme </div>
                      <select onchange="actualiserAssociationIndiceEnigme(this);">
                        {% for modeleEnigme in listeModeleEnigmes %}
                          <option {% if indice.modele_enigme.id == modeleEnigme.id %} selected {% endif %}>#{{ modeleEnigme.id }}</option>
                        {% endfor %}
                      </select>
                    {% else %}
                      <div>Aucune éngimes</div>
                    {% endif %}
                  </div>
                </li>
              {% endfor %}
            {% else %}
              <p id="aucun_indice">Aucun indice n'est encore ajouté</p>
            {% endif %}
          </ul>
        </section>
      </div>
    {% endif %}

    <section>
      <button couleur="supression" onClick="location.href='/escapes/modifier/{{ escape.id }}'">Retour</button>
      <button couleur="validation" onClick="enregistrerDonnees();" {% if not salleCourante %}disabled{% endif %}><ion-icon name="save" size="small"></ion-icon>Enregistrer</button>
    </section>
  </aside>

  <div id="modal2" class="modal">
    <section>
      {% if salleCourante.est_personnalisee == 1 %}
        <section>
          <button onclick="closeModal();"><ion-icon name="close" size="small"></ion-icon>Fermer</button>
          <h2>Paramètres des énigmes</h2>
        </section>
          <section>
            {% if salleCourante.salles %}
              {% if salleCourante.salles[0].enigmes_speciales and salleCourante.salles[0].enigme %}
                <p title="Dans le cas où à la fois une énigme personnalisée à été créé et une ou plusieurs énigmes pré-enregistrées ont été choisies, l'affichage final de l'énigme (personnalisée ou pré-enregistrée) sera déterminé avec ce bouton."><ion-icon name="information-circle-outline" size="small"></ion-icon>Utilisation finale</p>
                <ul>
                  <li{% if salleCourante.utilise_enigme_spe == 0 %} style="color: white; background-color:#476e86; border:1px solid lightgrey;"><ion-icon name="checkbox-outline" size="small"></ion-icon>{% else %}>{% endif %}Mode personnalisé</li>
                  <li><ion-icon name="sync-outline" size="large" onClick="location.href='modifier_mode_utilisation';"></ion-icon></li>
                  <li{% if salleCourante.utilise_enigme_spe == 1 %} style="color: white; background-color:#476e86; border:1px solid lightgrey;"><ion-icon name="checkbox-outline" size="small"></ion-icon>{% else %}>{% endif %}Mode pré-enregistré</li>
                </ul>
              {% endif %}
            {% else %}
              <p>Ajoutez des versions pour cet escape pour avoir accès à plus de paramètres</p>
            {% endif %}
          </section>
        <ul>
          <li>
            {% if enigmeSalle %}
              <section>
                <button onclick="if(confirm('Êtes-vous certain de vouloir supprimer l\'énigme ? \nCela ne supprimmera pas les indices que vous avez enregistrés.\nCette opération est irréversible !')){location.href='/scenario/modifier/{{ escape.id }}/salle/{{ salleCourante.id }}/supprimer/enigme/{{ enigmeSalle.id }}';}" couleur="supression"><ion-icon name="trash" size="small"></ion-icon>Supprimer</button>
                <h2>Énigme personnalisée</h2>
                <button onClick="closeModal();afficherModal('modal1');"><ion-icon name="settings" size="small"></ion-icon>Indices</button>
                <button couleur='validation' onClick="if(document.getElementById('form_enigme').checkValidity()){document.getElementById('form_enigme').submit();}"><ion-icon name="save" size="small"></ion-icon>Valider</button>
              </section>
              <section>
                <h4>Identifiant : #{{ enigmeSalle.id }}</h4>
                <form action="modifier/enigme/" method="POST" id="form_enigme">
                  <label>Intitulé</label>
                  <input type="text" name="enigme" placeholder="Combien font 2+2 ?" value="{{ enigmeSalle.intitule }}" />
                  <label>Solution</label>
                  <input type="text" name="solutionEnigme" placeholder="4" value="{{ enigmeSalle.solution }}" />
                  <label>Nombre de points accordés pour un sans fautes</label>
                  <input type="number" name="nbPoints" placeholder="10" min="0" value="{{ enigmeSalle.nb_points }}" />
                  <div>
                    <label>Image associée à l'énigme</label>
                    <div couleur="button" title="Changer l'image associée à l'énigme" onclick="document.getElementById('inputImageEnigme').click();">
                      <ion-icon name="image" size="small"></ion-icon>Image
                    </div>
                  </div>
                  <input onchange="changerImageEnigme();" type="file" id="inputImageEnigme" accept="image/*">
                  <input type="hidden" id="hiddenImageEnigme" name="hiddenImageEnigme"/>
                  <input type="hidden" name="idEnigme" value="{{ enigmeSalle.id }}"/>
                  {% if enigmeSalle.image %}
                    <img id="imageEnigme" src="{{ enigmeSalle.image.image }}" alt="Image associée à l'enigme" />
                  {% else %}
                    <img id="imageEnigme" alt="Image associée à l'enigme" style="display:none" alt="Image associée à l'enigme" />
                    <p>Aucune image n'est encore associée à cette énigme</p>
                  {% endif %}
                </form>
              </section>
            {% else %}
              <section>
                <h2>Énigme Personnalisée</h2>
              </section>
              <section>
                <button couleur="validation" onClick="location.href='ajouter/enigme';"><ion-icon name="add-circle-outline" size="small"></ion-icon>Créer une énigme personnalisée</button>
              </section>
            {% endif %}
          </li>
          <li>
            {% if salleCourante.salles and salleCourante.salles[0].enigmes_speciales %}
              <section>
                <h2>Énigme pré-enregistrée</h2>
                <button couleur="validation" onClick="closeModal();afficherModal('modal3');"><ion-icon name="add-circle-outline" size="small"></ion-icon>Ajouter</button>
              </section>
              <section>
                <ul id="listeGroupes">
                  {% for groupe in ListeGroupe %}
                    {% if groupe.enigmes_speciales[0] in salleCourante.salles[0].enigmes_speciales %}
                      <li>
                        <ion-icon name="trash" size="small" onclick="if(confirm('Êtes-vous certain de vouloir supprimer l\'association ? \nCela ne supprimmera ni l\'énigme pré-enregistrée ni ses indices.\nCette opération est irréversible !')){location.href='enigmeSpe/supprimer/{{ groupe.enigmes_speciales[0].id }}';}"></ion-icon>
                        <p>{{ groupe.nom }}</p>
                        <ion-icon name="information-circle-outline" title="Informations" onClick="afficherEnigmeSpeGroupe({{ groupe.id }})" size="small"></ion-icon>
                      </li>
                    {% endif %}
                  {% endfor %}
                </ul>
                {% for groupe in ListeGroupe %}
                  {% if groupe.enigmes_speciales[0] in salleCourante.salles[0].enigmes_speciales %}
                    <div id="GroupeInfosEnigmeSpe-{{ groupe.id }}" style="display:none">
                      <button onclick="cacherEnigmeSpeGroupe({{ groupe.id }});"><ion-icon name="arrow-back-outline" size="small"></ion-icon>Retour</button>
                      <h4>Critère de choix</h4>
                      <label>Intitulé</label>
                      <input type="text" value="{{ salleCourante.salles[0].enigmes_speciales[0].intitule }}" disabled>
                      <label>Solution</label>
                      <input type="text" value="{{ salleCourante.salles[0].enigmes_speciales[0].solution }}" disabled>
                      <label>Nombre de points pour un sans fautes</label>
                      <input type="text" value="{{ salleCourante.salles[0].enigmes_speciales[0].nb_points }}" disabled>
                      <label>Thème</label>
                      <input type="text" value="{{ salleCourante.salles[0].enigmes_speciales[0].theme.nom }}" disabled>
                      <label>Difficulté</label>
                      <input type="text" value="{{ salleCourante.salles[0].enigmes_speciales[0].difficulte.nom }}" disabled>
                    </div>
                  {% endif %}
                {% endfor %}
              </section>
            {% else %}
              <section>
                <h2>Énigme pré-enregistrée</h2>
              </section>
              <section>
                <button couleur="validation" onClick="closeModal();afficherModal('modal3');"><ion-icon name="add-circle-outline" size="small"></ion-icon>Choisir une énigme pré-enregistrée</button>
              </section>
            {% endif %}
          </li>
        </ul>
      {% else %}
        {% if salleCourante.salles and salleCourante.salles[0].enigmes_speciales %}
          <section>
            <button onclick="if(confirm('Êtes-vous certain de vouloir supprimer les associations ? \nCela ne supprimmera ni les énigmes pré-enregistrées ni leurs indices.\nCette opération est irréversible !')){location.href='enigmeSpe/supprimer/tout';}" couleur="supression"><ion-icon name="trash" size="small"></ion-icon>Supprimer</button>
            <h2>Énigme pré-enregistrée</h2>
            <button couleur='validation' title="Supprime les associations déjà en place puis choisi et associe au hasard une énigme par salle pour chaque groupe de cet escape game" onClick="if(document.getElementById('form_enigme_spe').checkValidity()){document.getElementById('form_enigme_spe').submit();}"><ion-icon name="save" size="small"></ion-icon>Re-associer</button>
          </section>

          <form action="enigme_speciale/" method="POST" id="form_enigme_spe">
            <div>
              <p style="background-color: #1aaa55;"><ion-icon name="checkbox-outline" size="small"></ion-icon>Association effectuée</p>
            </div>
            <p title="Choisisez la difficulté de l'énigme qui sera attribuée à cette salle"><ion-icon name="information-circle-outline"></ion-icon>Difficulté de l'énigme</p>
            <select form="form_enigme_spe" name="difficulte">
              <option value="1" {% if salleCourante.salles[0].enigmes_speciales[0].id_difficulte == 1 %}selected{% endif %}>Facile</option>
              <option value="2" {% if salleCourante.salles[0].enigmes_speciales[0].id_difficulte == 2 %}selected{% endif %}>Moyen</option>
              <option value="3" {% if salleCourante.salles[0].enigmes_speciales[0].id_difficulte == 3 %}selected{% endif %}>Difficile</option>
            </select>
            <p title="Choisisez le thème de l'énigme qui sera attribuée à cette salle"><ion-icon name="information-circle-outline"></ion-icon>Thème de l'énigme</p>
            <select form="form_enigme_spe" name="theme">
              {% for theme in listeTheme %}
                <option value="{{ theme.id }}" {% if salleCourante.salles[0].enigmes_speciales[0].id_theme == theme.id %}selected{% endif %}>{{ theme.nom }}</option>
              {% endfor %}
            </select>
          </form>
        {% else %}
          <section>
            <h2>Énigme pré-enregistrée</h2>
            <button title="Choisi et associe au hasard une énigme par salle pour chaque groupe de cet escape game" couleur='validation' onClick="if(document.getElementById('form_enigme_spe').checkValidity()){document.getElementById('form_enigme_spe').submit();}"><ion-icon name="save" size="small"></ion-icon>Associer</button>
          </section>

          <form action="enigme_speciale/" method="POST" id="form_enigme_spe">
            <div>
              <p style="background-color: #db3b21;"><ion-icon name="warning-outline" size="small"></ion-icon>Aucune énigme n'est encore associée</p>
            </div>
            <p title="Choisisez la difficulté de l'énigme qui sera attribuée à cette salle"><ion-icon name="information-circle-outline"></ion-icon>Difficulté de l'énigme</p>
            <select form="form_enigme_spe" name="difficulte">
              <option value="1">Facile</option>
              <option value="2">Moyen</option>
              <option value="3">Difficile</option>
            </select>
            <p title="Choisisez le thème de l'énigme qui sera attribuée à cette salle"><ion-icon name="information-circle-outline"></ion-icon>Thème de l'énigme</p>
            <select form="form_enigme_spe" name="theme">
              {% for theme in listeTheme %}
                <option value="{{ theme.id }}">{{ theme.nom }}</option>
              {% endfor %}
            </select>
          </form>
        {% endif %}
      {% endif %}
    </section>
  </div>

  <div id="modal3" class="modal">
    <section>
      <section>
        <button onclick="closeModal();afficherModal('modal2');"><ion-icon name="arrow-back-outline" size="small"></ion-icon>Retour</button>
        <h2>Liste des Enigmes</h2>
      </section>
      <ul>
        {% set listeTemp = [] %}
        {% if enigmesSpe %}
          {% for enigmeSpeciale in enigmesSpe %}
            {% if not enigmeSpeciale.groupes %}
                <li>
                  <section>
                    <p>{{ enigmeSpeciale.intitule }}</p>
                    <p>Difficulté : {{ enigmeSpeciale.difficulte.nom }}</p>
                    <p>Thème : {{ enigmeSpeciale.theme.nom }}</p>
                  </section>
                  <ion-icon name="play-outline" title="Ajouter l'énigme" onClick="closeModal();afficherModal('modal4');" size="small"></ion-icon>
                </li>
                <input form="ajouter_groupe" type="hidden" name="idEnigmeSpeChoisie" value="{{ enigmeSpeciale.id }}">
              {% else %}
                <p style="display:none">{{ listeTemp.append(enigmeSpeciale) }}</p>
              {% endif %}
          {% endfor %}
          {% if listeTemp|length == enigmesSpe|length %}
            <p>Toutes les énigmes spéciales sont alouées</p>
          {% endif %}
        {% else %}
          <p>Aucune énigme n'est encore ajoutée</p>
        {% endif %}
      </ul>
    </section>
  </div>

  <div id="modal4" class="modal">
    <section>
      <section>
        <button onclick="closeModal();afficherModal('modal3');"><ion-icon name="arrow-back-outline" size="small"></ion-icon>Retour</button>
        <h2>Lier l'énigme au groupe</h2>
      </section>
      {% if enigmesSpe %}
        <form action="ajouter/groupe" id="ajouter_groupe" method="POST">
          <ul>
            {% for groupe in listeVersions %}
              {% if groupe.enigmes_speciales[0] not in salleCourante.salles[0].enigmes_speciales %}
                <li>
                  <p>{{ groupe.nom }}</p>
                  <ion-icon name="play-outline" title="Choisir ce groupe" onClick="choisirGroupePourAssociationEnigmeSpe({{ groupe.id }});" size="small"></ion-icon>
                </li>
              {% endif %}
            {% endfor %}
          </ul>
          <input type="hidden" name="idGroupeChoisi" id="idGroupeChoisi">
        </form>
      {% else %}
        <p>Aucun groupe n'est encore ajouté</p>
      {% endif %}
    </section>
  </div>

  <script src="{{ url_for('static', filename='js/pixi.min.js') }}"></script>
  <script src="{{ url_for('static', filename='js/modal.js') }}"></script>
  <script type="text/javascript" src="{{ url_for('static', filename='js/modifier-scenario.js') }}"></script>
  {% if salleCourante %}
    <form id="form_indices" action="indices/enregistrer" method="POST">
      <input type="hidden" name="listeIndices" />
    </form>
    <script type="text/javascript">
      {% if listeModeleEnigmes != [] %}
        {% for modeleEnigme in listeModeleEnigmes %}
          listeModeleEnigmes.push({{ modeleEnigme.id }});
        {% endfor %}
      {% endif %}
      initZones([{% for zone in listeZones %}[{{ zone.pos_x }}, {{ zone.pos_y }}, {{ zone.hauteur }}, {{ zone.largeur }}],{% endfor %}]);

      {% if salleCourante.est_personnalisee == 1 %}
        initIndices([{% for indice in listeIndices %}["{{ indice.id }}", "{{ indice.contenu }}", "{{ indice.modele_enigme.id }}", "{{ indice.image.image }}"],{% endfor %}]);
      {% endif %}

      {% if imageFond %}
        initBackground('{{ imageFond.image }}');
      {% endif %}
      chargerSalle();

      {% if codeJS %}
        {{ codeJS }}
      {% endif %}
    </script>
  {% endif %}
{% endblock %}
